// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#include <aoc/MullItOver.hpp>

#include <aoc/StringStateMachine.hpp>

MullItOver::MullItOver()
    : Solver{}, data_{}, states_ { data_ }
{
}

const std::string MullItOver::getPuzzleName() const
{
    return "Day 3: Mull It Over";
}

const std::string MullItOver::getInputFileName() const
{
    return "mull_it_over.txt";
}

void MullItOver::processDataLine(const std::string& line)
{
    StringStateMachine stateMachine{ line, states_.entryState };
    stateMachine.run();
}

void MullItOver::finish()
{
    part1 = data_.getResultPart1();
    part2 = data_.getResultPart2();
}
